$
$  TOPPERS ATK2
$      Toyohashi Open Platform for Embedded Real-Time Systems
$      Automotive Kernel Version 2
$
$  Copyright (C) 2011-2013 by Center for Embedded Computing Systems
$              Graduate School of Information Science, Nagoya Univ., JAPAN
$  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
$  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
$  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
$  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
$  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
$  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
$  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
$  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
$
$  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
$  ܥեȥѤΤޤࡥʲƱˤѡʣ
$  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
$  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
$      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
$      ˴ޤޤƤ뤳ȡ
$  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
$      ѤǤǺۤˤϡۤȼɥȡ
$      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
$      ̵ݾڵǺܤ뤳ȡ
$  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
$      ѤǤʤǺۤˤϡΤ줫ξ
$      ȡ
$    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
$        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
$    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
$        𤹤뤳ȡ
$  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
$      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
$      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
$      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
$      դ뤳ȡ
$
$  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
$  TOPPERSץȤϡܥեȥ˴ؤơλŪ
$  ФŬޤơʤݾڤԤʤޤܥեȥ
$  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
$  Ǥʤ
$
$  $Id: kernel_xml.tf 8077 2013-12-24 00:14:29Z fsi-dankei $
$

$ =====================================================================
$ kernel.tfν˽ե
$ XMLΥǡ¤­ʤǡ
$ ̲Ǥʤ顼
$ =====================================================================

$TRACE("EXEC kernel_xml.tf")$

$ kernel.tf¹ԤǤʤ褦ʥ顼ȯ
$FATAL = 0$

$ =====================================================================
$ booleanȽؿ
$ =====================================================================

$FUNCTION IS_TRUE$
	$true_list = {1, "1", "true", "TRUE", "ON", "ENABLE"}$
	$false_list = {0, "0", "false", "FALSE", "OFF", "DISABLE"}$
	$error_flag = 1$
	
	$FOREACH false false_list$
		$IF EQ(false, ARGV[1])$
			$check_result = VALUE("FALSE", 0)$
			$error_flag = 0$
		$END$
	$END$
	$FOREACH true true_list$
		$IF EQ(true, ARGV[1])$
			$check_result = VALUE("TRUE", 1)$
			$error_flag = 0$
		$END$
	$END$

	$IF error_flag > 0$
		$ERROR ARGV[2]$$FORMAT(_("%1% must be boolean type"), ARGV[1])$$END$
	$END$

	$RESULT = check_result$
$END$

$ =====================================================================
$ booleanѴ
$ =====================================================================

$OS.STACKMONITORING[1] = IS_TRUE(OS.STACKMONITORING[1], OS.TEXT_LINE[1])$
$OS.GETSERVICEID[1] = IS_TRUE(OS.GETSERVICEID[1], OS.TEXT_LINE[1])$
$OS.PARAMETERACCESS[1] = IS_TRUE(OS.PARAMETERACCESS[1], OS.TEXT_LINE[1])$
$HOOK.STARTUPHOOK[1] = IS_TRUE(HOOK.STARTUPHOOK[1], HOOK.TEXT_LINE[1])$
$HOOK.SHUTDOWNHOOK[1] = IS_TRUE(HOOK.SHUTDOWNHOOK[1], HOOK.TEXT_LINE[1])$
$HOOK.PRETASKHOOK[1] = IS_TRUE(HOOK.PRETASKHOOK[1], HOOK.TEXT_LINE[1])$
$HOOK.POSTTASKHOOK[1] = IS_TRUE(HOOK.POSTTASKHOOK[1], HOOK.TEXT_LINE[1])$
$HOOK.ERRORHOOK[1] = IS_TRUE(HOOK.ERRORHOOK[1], HOOK.TEXT_LINE[1])$
$HOOK.PROTECTIONHOOK[1] = IS_TRUE(HOOK.PROTECTIONHOOK[1], HOOK.TEXT_LINE[1])$
$FOREACH schtblid SCHTBL.ID_LIST$
	$SCHTBL.REPEAT[schtblid] = IS_TRUE(SCHTBL.REPEAT[schtblid],SCHTBL.TEXT_LINE[schtblid])$
$END$

$ =====================================================================
$ ޥͤȥޥIDפ
$ =====================================================================
$IF LENGTH(OS.MASTERCOREID[1]) && OS.MASTERCOREID[1] != OS_CORE_ID_MASTER$
	$FATAL = 1$
	$ERROR OS.TEXT_LINE[1]$$FORMAT(_("OsMasterCoreId `%1%'  is not equal to target-defined master core id(`%2%')"), OS.MASTERCOREID[1], +OS_CORE_ID_MASTER)$$END$
$END$

$ =====================================================================
$ HOOK.PROTECTIONHOOKʤFALSE
$ =====================================================================

$IF !LENGTH(HOOK.PROTECTIONHOOK[1])$
	$HOOK.PROTECTIONHOOK[1] = VALUE("false", 0)$
$END$

$ =====================================================================
$ OSAPΥ顼åȴϢŤ
$ =====================================================================

$FOREACH osapid OSAP.ID_LIST$
	$FOREACH tskid OSAP.TSK_LIST[osapid]$
		$IF LENGTH(TSK.OSAPID[tskid])$
			$ERROR OSAP.TEXT_LINE[osapid]$$FORMAT(_("Task `%1%' belongs to another OSApplication `%2%'"), tskid, TSK.OSAPID[tskid])$$END$
		$ELSE$
			$TSK.OSAPID[tskid] = osapid$
		$END$
	$END$

	$FOREACH cntid OSAP.CNT_LIST[osapid]$
		$IF LENGTH(CNT.OSAPID[cntid])$
			$ERROR OSAP.TEXT_LINE[osapid]$$FORMAT(_("Counter `%1%' belongs to another OSApplication `%2%'"), cntid, CNT.OSAPID[cntid])$$END$
		$ELSE$
			$CNT.OSAPID[cntid] = osapid$
		$END$
	$END$

	$FOREACH almid OSAP.ALM_LIST[osapid]$
		$IF LENGTH(ALM.OSAPID[almid])$
			$ERROR OSAP.TEXT_LINE[osapid]$$FORMAT(_("Alarm `%1%' belongs to another OSApplication `%2%'"), almid, ALM.OSAPID[almid])$$END$
		$ELSE$
			$ALM.OSAPID[almid] = osapid$
		$END$
	$END$

	$FOREACH isrid OSAP.ISR_LIST[osapid]$
		$IF LENGTH(ISR.OSAPID[isrid])$
			$ERROR OSAP.TEXT_LINE[osapid]$$FORMAT(_("ISR `%1%' belongs to another OSApplication `%2%'"), isrid, ISR.OSAPID[isrid])$$END$
		$ELSE$
			$ISR.OSAPID[isrid] = osapid$
		$END$
	$END$

	$FOREACH iciid OSAP.ICI_LIST[osapid]$
		$IF LENGTH(ICI.OSAPID[iciid])$
			$ERROR OSAP.TEXT_LINE[osapid]$$FORMAT(_("OsInterCoreInterrupt `%1%' belongs to another OSApplication `%2%'"), iciid, ICI.OSAPID[iciid])$$END$
		$ELSE$
			$ICI.OSAPID[iciid] = osapid$
		$END$
	$END$

	$FOREACH schtblid OSAP.SCHTBL_LIST[osapid]$
		$IF LENGTH(SCHTBL.OSAPID[schtblid])$
			$ERROR OSAP.TEXT_LINE[osapid]$$FORMAT(_("ScheduleTable `%1%' belongs to another OSApplication `%2%'"), schtblid, SCHTBL.OSAPID[schtblid])$$END$
		$ELSE$
			$SCHTBL.OSAPID[schtblid] = osapid$
		$END$
	$END$
$END$

$ OSAP.HOOK.*OSAP.*˥ԡ
$FOREACH hookid OSAP.HOOK.ID_LIST$
	$osapid = OSAP.HOOK.PARENT[hookid]$
	$OSAP.STARTUPHOOK[osapid] = IS_TRUE(OSAP.HOOK.STARTUPHOOK[hookid], OSAP.TEXT_LINE[osapid])$
	$OSAP.SHUTDOWNHOOK[osapid] = IS_TRUE(OSAP.HOOK.SHUTDOWNHOOK[hookid], OSAP.TEXT_LINE[osapid])$
	$OSAP.ERRORHOOK[osapid] = IS_TRUE(OSAP.HOOK.ERRORHOOK[hookid], OSAP.TEXT_LINE[osapid])$
$END$


$ =====================================================================
$ OSTK.STKʤNULL
$ =====================================================================

$FOREACH ostkid OSTK.ID_LIST$
	$IF !LENGTH(OSTK.STK[ostkid])$
		$OSTK.STK[ostkid] = "NULL"$
	$END$
$END$


$ =====================================================================
$ TSKΥ顼åȴϢŤ
$ =====================================================================

$TRACE("ASSOCIATE TASK")$

$ TSK.AUTOSTARTTSK˥ԡ
$FOREACH aid TSK.AUTOSTART.ID_LIST$
	$tskid                = TSK.AUTOSTART.PARENT[aid]$
	$TSK.APP_LIST[tskid]  = TSK.AUTOSTART.APP_LIST[aid]$
$END$


$FOREACH tskid TSK.ID_LIST$
$   // ά줿NULLˤ
	$IF !LENGTH(TSK.STK[tskid])$
		$TSK.STK[tskid] = "NULL"$
	$END$
$	// åΥǥե
	$IF !LENGTH(TSK.STKSZ[tskid])$
		$TSK.STKSZ[tskid] = DEFAULT_TASKSTKSZ$
	$END$
$END$


$ =====================================================================
$ ISRΥ顼åȴϢŤ
$ =====================================================================

$TRACE("ASSOCIATE ISR")$

$FOREACH isrid ISR.ID_LIST$
	$IF LENGTH(ISR.INTATR[isrid])$
		$ISR.INTATR[isrid] = VALUE(CONCAT(ISR.INTATR[isrid], " | ENABLE"), ISR.INTATR[isrid] | ENABLE)$
	$ELSE$
		$ISR.INTATR[isrid] = ENABLE$
	$END$

	$IF EQ(ISR.CATEGORY[isrid], "CATEGORY_1")$
		$IF LENGTH(ISR.STKSZ[isrid])$
			$ERROR ISR.TEXT_LINE[isrid]$$FORMAT(_("OsIsrStackSize of C1ISR OsIsr(%1%) must not define"), isrid)$$END$
		$ELSE$
			$ISR.STKSZ[isrid] = 0$
		$END$
	$ELIF EQ(ISR.CATEGORY[isrid], "CATEGORY_2")$
		$IF LENGTH(ISR.STKSZ[isrid]) && (ISR.STKSZ[isrid] == 0)$
			$ERROR ISR.TEXT_LINE[isrid]$$FORMAT(_("OsIsrStackSize of C2ISR OsIsr(%1%) should not defined zero"), isrid)$$END$
		$END$
$		// C2ISRåΥǥե
		$IF !LENGTH(ISR.STKSZ[isrid])$
			$ISR.STKSZ[isrid] = DEFAULT_ISRSTKSZ$
		$END$
	$END$
$END$


$ =====================================================================
$ DEF_ICIΥ顼åȴϢŤ
$ =====================================================================

$TRACE("ASSOCIATE ICISR")$

$FOREACH iciid ICI.ID_LIST$
	$IF LENGTH(ICI.STKSZ[iciid]) && (ICI.STKSZ[iciid] == 0)$
		$ERROR ICI.TEXT_LINE[iciid]$$FORMAT(_("OsInterCoreInterruptStackSize of ICISR OsInterCoreInterrupt(%1%) should not defined zero"), iciid)$$END$
	$END$
$	// ICISRåΥǥե
	$IF !LENGTH(ICI.STKSZ[iciid])$
		$ICI.STKSZ[iciid] = DEFAULT_ISRSTKSZ$
	$END$
$END$


$ =====================================================================
$ EVT˴ؤ
$ =====================================================================

$FOREACH evtid EVT.ID_LIST$
$	// ޥά줿AUTOˤ
	$IF !LENGTH(EVT.MASK[evtid])$
		$EVT.MASK[evtid] = AUTO$
	$END$
$END$


$ =====================================================================
$ CNT˴ؤ
$ =====================================================================

$FOREACH cntid CNT.ID_LIST$
	$IF EQ(CNT.CNTATR[cntid], "HARDWARE")$
		$IF !LENGTH(CNT.ISRID[cntid])$
			$FATAL = 1$
			$ERROR CNT.TEXT_LINE[cntid]$$FORMAT(_("OsCounterIsrRef of HARDWARE OsCounter(%1%) is not defined"), cntid)$$END$
		$END$

$		// NSPERTICKSECONDSPERTICK׻
		$IF LENGTH(CNT.SECONDSPERTICK[cntid])$
			$CNT.NSPERTICK[cntid] = CONCAT(CNT.SECONDSPERTICK[cntid], " * 1000000000")$
		$END$
	$END$
$END$


$ =====================================================================
$ ALM˴ؤ
$ =====================================================================

$TRACE("ASSOCIATE ALARM")$

$ ALM.AUTOSTART.*ALM.*˥ԡ
$FOREACH aid ALM.AUTOSTART.ID_LIST$
	$almid                              = ALM.AUTOSTART.PARENT[aid]$
	$ALM.APP_LIST[almid]                = ALM.AUTOSTART.APP_LIST[aid]$
	$ALM.ALARMTIME[almid]               = ALM.AUTOSTART.ALARMTIME[aid]$
	$ALM.CYCLETIME[almid]               = ALM.AUTOSTART.CYCLETIME[aid]$
	$ALM.AUTOSTARTTYPE[almid]           = ALM.AUTOSTART.TYPE[aid]$
$END$

$FOREACH almid ALM.ID_LIST$
	$ALM.ALMATR_COUNT[almid] = 0$
$END$

$ ALM.ACTION.ACTIVATETASK.*ALM.*˥ԡ
$FOREACH almactid ALM.ACTION.ACTIVATETASK.ID_LIST$
	$almid                      = ALM.ACTION.PARENT[ALM.ACTION.ACTIVATETASK.PARENT[almactid]]$
	$ALM.ALMATR[almid]          = "ACTIVATETASK"$
	$ALM.TSKID[almid]           = ALM.ACTION.ACTIVATETASK.TSKID[almactid]$
	$ALM.ALMATR_COUNT[almid]    = ALM.ALMATR_COUNT[almid] + 1$
$END$

$ ALM.ACTION.SETEVENT.*ALM.*˥ԡ
$FOREACH almactid ALM.ACTION.SETEVENT.ID_LIST$
	$almid                      = ALM.ACTION.PARENT[ALM.ACTION.SETEVENT.PARENT[almactid]]$
	$ALM.ALMATR[almid]          = "SETEVENT"$
	$ALM.TSKID[almid]           = ALM.ACTION.SETEVENT.TSKID[almactid]$
	$ALM.EVTID[almid]           = ALM.ACTION.SETEVENT.EVTID[almactid]$
	$ALM.ALMATR_COUNT[almid]    = ALM.ALMATR_COUNT[almid] + 1$
$END$

$ ALM.ACTION.CALLBACK.*ALM.*˥ԡ
$FOREACH almactid ALM.ACTION.CALLBACK.ID_LIST$
	$almid                         = ALM.ACTION.PARENT[ALM.ACTION.CALLBACK.PARENT[almactid]]$
	$ALM.ALMATR[almid]             = "CALLBACK"$
	$ALM.CALLBACK[almid]           = ALM.ACTION.CALLBACK.CALLBACK[almactid]$
	$ALM.ALMATR_COUNT[almid]       = ALM.ALMATR_COUNT[almid] + 1$
$END$

$ ALM.ACTION.INCREMENTCOUNTER.*ALM.*˥ԡ
$FOREACH almactid ALM.ACTION.INCREMENTCOUNTER.ID_LIST$
	$almid                      = ALM.ACTION.PARENT[ALM.ACTION.INCREMENTCOUNTER.PARENT[almactid]]$
	$ALM.ALMATR[almid]          = "INCREMENTCOUNTER"$
	$ALM.INCID[almid]           = ALM.ACTION.INCREMENTCOUNTER.INCID[almactid]$
	$ALM.ALMATR_COUNT[almid]    = ALM.ALMATR_COUNT[almid] + 1$
$END$

$FOREACH almid ALM.ID_LIST$
$ 	//ALM.ACTION.*2İʾƤʤ
	$IF ALM.ALMATR_COUNT[almid] != 1$
		$FATAL = 1$
		$ERROR ALM.TEXT_LINE[almid]$$FORMAT(_("OsAlarmAction of OsAlarm(%1%) have too many sub container"), almid)$$END$
	$END$
$END$


$ =====================================================================
$ SCHTBL˴ؤ
$ =====================================================================

$TRACE("ASSOCIATE SCHTBL")$

$ ά줿NONEˤ
$FOREACH schtblid SCHTBL.ID_LIST$
	$SCHTBL.SYNCSTRATEGY[schtblid] = "NONE"$
$END$

$ SCHTBL.AUTOSTART.*SCHTBL.*˥ԡ
$FOREACH aid SCHTBL.AUTOSTART.ID_LIST$
	$schtblid                                 = SCHTBL.AUTOSTART.PARENT[aid]$
	$SCHTBL.APP_LIST[schtblid]                = SCHTBL.AUTOSTART.APP_LIST[aid]$
	$IF LENGTH(SCHTBL.AUTOSTART.STARTTICK[aid])$
		$SCHTBL.STARTTICK[schtblid]           = SCHTBL.AUTOSTART.STARTTICK[aid]$
	$ELSE$
$		// ά줿Ȥ򼨤
		$SCHTBL.STARTTICK[schtblid]           = "NULL"$
	$END$
	$SCHTBL.AUTOSTARTTYPE[schtblid]           = SCHTBL.AUTOSTART.TYPE[aid]$
$END$

$FOREACH syncid SCHTBL.SYNC.ID_LIST$
	$schtblid = SCHTBL.SYNC.PARENT[syncid]$
	$SCHTBL.SYNCSTRATEGY[schtblid] = SCHTBL.SYNC.STRATEGY[syncid]$
$END$


$ =====================================================================
$ EXPPTACT˴ؤ
$ =====================================================================

$ SCHTBL.EXPPT.ACTIVATETASK.*EXPPTACT˥ԡ
$i = 0$
$FOREACH acttskid SCHTBL.EXPPT.ACTIVATETASK.ID_LIST$
	$expid                          = SCHTBL.EXPPT.ACTIVATETASK.PARENT[acttskid]$
	$schtblid                       = SCHTBL.EXPPT.PARENT[expid]$

	$EXPPTACT.SCHTBLID[i]           = schtblid$
	$EXPPTACT.OFFSET[i]             = SCHTBL.EXPPT.OFFSET[expid]$
	$EXPPTACT.TSKID[i]              = SCHTBL.EXPPT.ACTIVATETASK.TSKID[acttskid]$
	$EXPPTACT.EXPIREATR[i]          = "ACTIVATETASK"$

	$EXPPTACT.ID_LIST               = APPEND(EXPPTACT.ID_LIST, i)$
	$i                              = i + 1$
$END$

$ SCHTBL.EXPPT.SETEVENT.*EXPPTACT˥ԡ
$FOREACH setevid SCHTBL.EXPPT.SETEVENT.ID_LIST$
	$expid                          = SCHTBL.EXPPT.SETEVENT.PARENT[setevid]$
	$schtblid                       = SCHTBL.EXPPT.PARENT[expid]$

	$EXPPTACT.SCHTBLID[i]           = schtblid$
	$EXPPTACT.OFFSET[i]             = SCHTBL.EXPPT.OFFSET[expid]$
	$EXPPTACT.TSKID[i]              = SCHTBL.EXPPT.SETEVENT.TSKID[setevid]$
	$EXPPTACT.EVTID[i]              = SCHTBL.EXPPT.SETEVENT.EVTID[setevid]$
	$EXPPTACT.EXPIREATR[i]          = "SETEVENT"$

	$EXPPTACT.ID_LIST               = APPEND(EXPPTACT.ID_LIST, i)$
	$i                              = i + 1$
$END$


$ =====================================================================
$ CRE_SPNΥ顼åȴϢŤ
$ =====================================================================
$FOREACH spnid SPN.ID_LIST$
	$SPN.SPN[spnid] = spnid$
$END$
$FOREACH spnid SPN.ID_LIST$
$	// LOCKMETHODƥå"LOCK_ALL_INTERRUPTS","LOCK_CAT2_INTERRUPTS","LOCK_NOTHING"ʳʤ饨顼
	$IF !(EQ(SPN.LOCKMETHOD[spnid], "LOCK_ALL_INTERRUPTS") || EQ(SPN.LOCKMETHOD[spnid], "LOCK_CAT2_INTERRUPTS") || EQ(SPN.LOCKMETHOD[spnid], "LOCK_NOTHING"))$
		$ERROR SPN.TEXT_LINE[spnid]$$FORMAT(_("OsSpinlockLockMethod of OsSpinlock must be LOCK_ALL_INTERRUPTS or LOCK_CAT2_INTERRUPTS or LOCK_NOTHING"))$$END$
	$END$

$	// SUCCESSORΥå
	$IF LENGTH(SPN.SUCCESSOR[spnid]) && !EQ(SPN.SUCCESSOR[spnid],"NULL")$
		$next_spn = SPN.SUCCESSOR[spnid]$
		$find = 0$

$		// SUCCESSORSPNIDδϢŤ
		$FOREACH temp SPN.ID_LIST$
			$IF EQ(SPN.SPN[temp] , next_spn)$
				$SPN.SUCCESSOR_ID[spnid] = +temp$
				$find = 1$
			$END$
		$END$
		
$		// SUCCESSOR¸ߤƤ뤫
		$IF !find$
			$ERROR SPN.TEXT_LINE[spnid]$$FORMAT(_("illeagl %1% `%2%\' in %3%"),"successor", SPN.SUCCESSOR[spnid], "OsSpinlockSuccessor")$$END$
		$END$
	$END$
	
	$new_list = {}$
	$FOREACH osap SPN.ACS_OSAP_LIST[spnid]$
		$find = 0$
		$FOREACH osapid OSAP.ID_LIST$
			$IF EQ(osap, osapid)$
				$new_list = APPEND(new_list, osapid)$
				$find = 1$
			$END$
		$END$
$		// osap¸ߤ뤫
		$IF !find$
			$ERROR SPN.TEXT_LINE[spnid]$$FORMAT(_("illegal %1% `%2%\'"), "OSApplication", osap)$$END$
		$END$
	$END$
	$SPN.ACS_OSAP_LIST[spnid] = new_list$

$	// osapꤵƤ뤫
	$IF !LENGTH(SPN.ACS_OSAP_LIST[spnid])$
		$ERROR SPN.TEXT_LINE[spnid]$$FORMAT(_("OsSpinlockAccessingApplication of OsSpinlock(%1%) is not defined"), spnid)$$END$
	$END$

$END$


$ =====================================================================
$ IOC˴ؤ
$ =====================================================================

$ OSIOC.IOCPRIM.DATATYPEIOCPRIM.DATATYPE˥ԡID_LISTκ
$new_id_list = {}$
$FOREACH osiocid OSIOC.ID_LIST$
	$new_id_list = APPEND(new_id_list, OSIOC.IOCPRIM.DATATYPE[osiocid])$
	$IOCPRIM.DATATYPE[osiocid] = OSIOC.IOCPRIM.DATATYPE[osiocid]$
$END$
$IOCPRIM.ID_LIST = new_id_list$

$ OsIocCommunication -> CRE_IOC
$FOREACH iocid IOC.ID_LIST$
$ 	// ά줿ѥ᡼NULL
	$IF !LENGTH(IOC.BUFLEN[iocid])$
		$IOC.BUFLEN[iocid] = VALUE("NULL", 0)$
	$END$
$END$

$ OsIocDataProperties -> DEF_IOC_DATA
$FOREACH iocdataid IOCDATA.ID_LIST$
$ 	// IOCDATA.PARENTIOCDATA.IOCإԡ
	$IOCDATA.IOC[iocdataid]  = IOCDATA.PARENT[iocdataid]$

$ 	// ά줿ѥ᡼NULL(IOCDATA.FILEŪAPIǤάǽʤʤ)
	$IF !LENGTH(IOCDATA.INDEX[iocdataid])$
		$IOCDATA.INDEX[iocdataid] = "NULL"$
	$END$
	$IF !LENGTH(IOCDATA.INITVAL[iocdataid])$
		$IOCDATA.INITVAL[iocdataid] = "NULL"$
	$END$
$END$

$ OsIocSenderProperties -> DEF_IOC_SND
$FOREACH iocsndid IOCSND.ID_LIST$
$ 	// IOCSND.PARENTIOCSND.IOCإԡ
	$IOCSND.IOC[iocsndid]   = IOCSND.PARENT[iocsndid]$

$ 	// ά줿ѥ᡼NULL
	$IF !LENGTH(IOCSND.SENDERID[iocsndid])$
		$IOCSND.SENDERID[iocsndid] = "NULL"$
	$END$
	$IF !LENGTH(IOCSND.IMPLKIND[iocsndid])$
		$IOCSND.IMPLKIND[iocsndid] = "NULL"$
	$END$
$END$

$ OsIocReceiverProperties -> DEF_IOC_RCV
$FOREACH iocrcvid IOCRCV.ID_LIST$
$ 	// IOCRCV.PARENTIOCRCV.IOCإԡ
	$IOCRCV.IOC[iocrcvid] = IOCRCV.PARENT[iocrcvid]$
$END$


$IF FATAL$
	$DIE()$
$END$
